<template>
    <div  class="permalink-panel">
        <h3 class="text-center div_title">Partage</h3>
        <div class="container-form">
          Partagez la carte avec l'adresse suivante:
          <b-row align-v="center" class="mb-3">
            <b-col cols="10">
              <b-form-input ref="textInput" size="sm"
                v-model="permalink"
                class="form-control"
                type="text"></b-form-input>
            </b-col>
            <b-col cols="2">
              <div class="menu-item"
                v-b-tooltip.right.hover title="Copier dans le presse papier"
                @click="copy()">
                  <b-icon icon="clipboard-plus"></b-icon>
              </div>
            </b-col>
            </b-row>
            <b-alert :show="alertCountDown" variant="success" dismissible
            @dismissed="alertCountDown=0"
            @dismiss-count-down="countDownChanged"
            >
            <i>Url copiée dans le presse papier</i>
            </b-alert>
        </div>
    </div>
</template>

<script lang="ts">

import Component from 'vue-class-component';
import PluginComponent from '@/components/plugins/PluginComponent';
import { EventBus, EVENTS } from '@/services/EventBus';

@Component({
  props: {
  },
  components: {
  },
})
export default class PermalinkPlugin extends PluginComponent {
    static ID='PermalinkPlugin';

    permalink= 'test';

    copyDone = false;

    alertCountDown = 0;

    mounted():void {
      this.permalink = window.location.href;
      EventBus.$on(EVENTS.MAP_CURRENT_BBOX_CHANGE, (bbox:any) => this.onMoveEnd(bbox));
    }

    countDownChanged(dismissCountDown:any) {
      this.alertCountDown = dismissCountDown;
    }

    onMoveEnd(bbox:any):void {
      this.permalink = window.location.href;
    }

    copy():void{
      const copyText:any = this.$refs.textInput;
      copyText.select();
      copyText.setSelectionRange(0, 99999); // used for mobile phone
      document.execCommand('copy');
      this.alertCountDown = 5;
    }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

.menu-item{
  font-size: 25px;
  cursor: pointer;
  text-align: center;
  color: @first;
}
</style>
